#!/bin/bash
# cd to puppet floder location, which depends on which rpms puppet was installed from
if [ -d '/etc/puppet' ]; then
  cd /etc/puppet
fi

if [ -d '/etc/puppetlabs/puppet' ]; then

  if [ "$(grep -c 'Customized by Dell' /etc/puppetlabs/httpd/conf.d/puppetmaster.conf)" -eq "0" ]; then 
    echo 'rpmPup4AsmPostinstall.sh customizing puppetmaster.conf'
    cat /opt/Dell/conf/puppetmaster.conf > /etc/puppetlabs/httpd/conf.d/puppetmaster.conf
  fi
  echo 'rpmPup4AsmPostinstall.sh customizing headers.conf'
  cat /opt/Dell/conf/headers.conf > /etc/puppetlabs/httpd/conf.d/headers.conf
  if [ "$(grep -c 'Customized by Dell' /etc/rc.d/init.d/pe-httpd)" -eq "0" ]; then 
    echo 'rpmPup4AsmPostinstall.sh customizing pe-httpd service script'
    cat /opt/Dell/scripts/pe-httpd > /etc/rc.d/init.d/pe-httpd
  fi
  
  if [ ! -f /etc/sysconfig/puppetmaster ]; then 
    cd /etc/sysconfig
    echo 'creating link /etc/sysconfig/puppetmaster -> /opt/Dell/conf/puppetmaster'
    ln -s /opt/Dell/conf/puppetmaster
  fi

  if [ ! -d /var/opt/lib/pe-puppetmaster/public ]; then
     mkdir -p /var/opt/lib/pe-puppetmaster/public
     chown -R pe-puppet:pe-puppet /var/opt/lib/pe-puppetmaster
  fi
  
  # an empty config.ru may be installed by a separate rpm, so using postinstall script to customize it
  if [ ! -f /var/opt/lib/pe-puppetmaster/config.ru ]; then
    echo 'rpmPup4AsmPostinstall.sh installed pe-puppetmaster/config.ru'
    cat /opt/Dell/conf/config.ru > /var/opt/lib/pe-puppetmaster/config.ru
    chown pe-puppet:pe-puppet /var/opt/lib/pe-puppetmaster/config.ru
    chmod 644 /var/opt/lib/pe-puppetmaster/config.ru
  fi
  if [ "$(grep -c 'Installed by Dell-ASM-pupconf' /var/opt/lib/pe-puppetmaster/config.ru)" -eq "0" ]; then 
    echo 'rpmPup4AsmPostinstall.sh customizing pe-puppetmaster/config.ru'
    cat /opt/Dell/conf/config.ru > /var/opt/lib/pe-puppetmaster/config.ru
  fi
  
  # might need to create /var/opt/lib/pe-puppetmaster directory
  # this cd should be the last cd in this block, as the lines after fi depend on
  # being in the puppet home  
  cd /etc/puppetlabs/puppet
fi

mkdir -p modules
if [ ! -f autosign.conf ]; then 
  pwd
  echo 'creating link autosign.conf -> /opt/Dell/conf/autosign.conf'
  ln -s /opt/Dell/conf/autosign.conf
fi

if [ -d '/etc/puppetlabs/puppet' ]; then
  chown -R pe-puppet:pe-puppet modules
  mkdir -p /var/opt/lib/pe-puppetmaster
  chown pe-puppet:pe-puppet /var/opt/lib/pe-puppetmaster
  touch /var/opt/lib/pe-puppetmaster/config.ru
  chown pe-puppet:pe-puppet /var/opt/lib/pe-puppetmaster/config.ru
  mkdir -p /etc/puppetlabs/puppet/files
  chown root:pe-puppet /etc/puppetlabs/puppet/files
  mkdir -p /etc/puppetlabs/puppet/manifests
  chown root:pe-puppet /etc/puppetlabs/puppet/manifests
else
  chown -R puppet:puppet modules
fi


# cd to puppetdb/conf.d location, which depends on which rpms puppet was installed from
if [ -d '/etc/puppetdb/conf.d' ]; then
  cd /etc/puppetdb/conf.d
fi

if [ -d '/etc/puppetlabs/puppetdb/conf.d' ]; then
  cd /etc/puppetlabs/puppetdb/conf.d
fi

if [ ! -f databasePostgres.ini ]; then 
  pwd
  echo 'creating link databasePostgres.ini -> /opt/Dell/conf/databasePostgres.ini'
  ln -s /opt/Dell/conf/databasePostgres.ini
fi
sed -i 's/8082/7081/' repl.ini
sed -i 's/8080/7080/' jetty.ini
# remove default database.ini  It has been replaced by databasePostgres.ini
rm -f database.ini

cd /opt/Dell/scripts
if [ ! -f '/opt/Dell/rpmPup4AsmPostinstall-complete' ]; then
  # these are actions we only need to perform the first time the rpm is installed
  export LANG=en_US.UTF-8
  ./postgresql-puppetconfigure.exp rd123 Pas
  /bin/sleep 10
  touch /opt/Dell/rpmPup4AsmPostinstall-complete
fi

if [ -d '/etc/puppet' ]; then
cd /etc/puppet
fi

if [ -d '/etc/puppetlabs/puppet' ]; then
cd /etc/puppetlabs/puppet
fi

cat /opt/Dell/conf/puppetdb.conf >puppetdb.conf
cat /opt/Dell/conf/puppet.conf >puppet.conf

# Add /opt/asm-deployer/lib so that code can be shared between it (torquebox
# REST services) and puppet modules
if ! grep RUBYLIB /etc/environment >& /dev/null; then
    echo "export RUBYLIB=/opt/asm-deployer/lib">>/etc/environment
fi

if ! grep LANG /etc/environment >& /dev/null; then
    echo "export LANG=en_US.UTF-8" >> /etc/environment
fi

if [ -f /etc/rc.d/init.d/puppetdb ]; then
 service puppetdb restart
fi

if [ -f /etc/rc.d/init.d/pe-puppetdb ]; then
 service pe-puppetdb restart
fi

if [ -f /etc/rc.d/init.d/puppet ]; then
 service puppet restart
fi

if [ -f /etc/rc.d/init.d/pe-puppet ]; then
 service pe-puppet restart
fi
